<template>
  <dashboard-layout>
    <Search
      :params="params"
      @onAdd="onAdd"
      @onChangeParams="onChangeParams"
      @onSearch="onSearch"
      @onClearSearch="onClearSearch"
    />
    <List
      :users="users"
      :pagination="pagination"
      :page="params.page"
      @onChangePage="onChangeParams"
      @onEdit="onEdit"
      @onDelete="onDelete"
      @onUpdateStatus="onUpdateStatus"
    />
    <DialogData
      :dialogData="dialogData"
      :userData="userData"
      @onChangeDialogData="onChangeDialogData"
      @onReloadList="onSearch"
    />
    <DialogDelete
      :dialogDelete="dialogDelete"
      :userDeleted="userDeleted"
      @onChangeDialogDelete="onChangeDialogDelete"
      @onReloadList="onSearch"
    />
    <DialogStatus
      :dialogStatus="dialogStatus"
      :userStatus="userStatus"
      @onChangeDialogStatus="onChangeDialogStatus"
      @onReloadList="onSearch"
    />
  </dashboard-layout>
</template>

<script>
import Search from "./../components/user/table/Search.vue";
import List from "./../components/user/table/List.vue";
import DialogData from "../components/user/data/DialogData.vue";
import DialogDelete from "../components/user/data/DialogDelete.vue";
import DialogStatus from "../components/user/data/DialogStatus.vue";
import userService from "../services/userService";

export default {
  components: {
    Search,
    List,
    DialogData,
    DialogDelete,
    DialogStatus,
  },
  data() {
    return {
      params: {
        page: 1,
        name: "",
        email: "",
        groupRole: "",
        isActive: "",
      },
      users: [],
      pagination: {
        from: 0,
        to: 0,
        total: 0,
        currentPage: 0,
        lastPage: 0,
      },
      dialogData: false,
      userData: {},
      dialogDelete: false,
      userDeleted: {
        id: 0,
        name: '',
      },
      dialogStatus: false,
      userStatus: {
        id: 0,
        name: '',
        isActive: 1,
      },
    };
  },
  methods: {
    async fetchData() {
      this.$store.commit("loading", true);
      await userService
        .getList(this.params)
        .then((response) => {
          this.$store.commit("loading", false);
          const responseData = response.data;
          this.users = responseData.data;
          this.pagination.from = responseData.from;
          this.pagination.to = responseData.to;
          this.pagination.total = responseData.total;
          this.pagination.currentPage = responseData.currentPage;
          this.pagination.lastPage = responseData.lastPage;
        })
        .catch((error) => {
          this.$store.commit("loading", false);
          let msgError = "";
          if (error.response.status === 422) {
            const dataErrors = error.response.data.errors;
            let errors = [];
            for (const [key, value] of Object.entries(dataErrors)) {
              errors.push(value);
            }
            msgError = errors.toString();
          } else {
            msgError = error.response.data.message;
          }
          this.$store.commit("showMessageError", msgError);
        });
    },
    onChangeParams({ key, value }) {
      this.params[key] = value;
      if (key === "page") {
        this.fetchData();
      }
    },
    onSearch() {
      this.params.page = 1;
      this.fetchData();
    },
    onClearSearch() {
      this.params = {
        page: 1,
        name: "",
        email: "",
        groupRole: "",
        isActive: "",
      };
      this.fetchData();
    },
    async fetchDetailData(id) {
      this.$store.commit("loading", true);
      await userService
        .getById(id)
        .then((response) => {
          this.$store.commit("loading", false);
          this.userData = response.data;
          this.userData.password = "";
          this.userData.passwordConfirmation = "";
        })
        .catch((error) => {
          this.$store.commit("loading", false);
          let msgError = "";
          if (error.response.status === 422) {
            const dataErrors = error.response.data.errors;
            let errors = [];
            for (const [key, value] of Object.entries(dataErrors)) {
              errors.push(value);
            }
            msgError = errors.toString();
          } else {
            msgError = error.response.data.message;
          }
          this.$store.commit("showMessageError", msgError);
        });
    },
    onAdd() {
      this.userData = {};
      this.onChangeDialogData(true);
    },
    async onEdit(id) {
      await this.fetchDetailData(id);
      this.onChangeDialogData(true);
    },
    onChangeDialogData(value) {
      this.dialogData = value;
    },
    async onDelete({id, name}) {
      this.userDeleted.id = id;
      this.userDeleted.name = name;
      this.onChangeDialogDelete(true);
    },
    onChangeDialogDelete(value) {
      this.dialogDelete = value;
    },
    async onUpdateStatus({id, name, isActive}) {
      this.userStatus.id = id;
      this.userStatus.name = name;
      this.userStatus.isActive = isActive;
      this.onChangeDialogStatus(true);
    },
    onChangeDialogStatus(value) {
      this.dialogStatus = value;
    },
  },
  async created() {
    await this.fetchData();
  },
};
</script>
